{ pkgs, ... }:
{
  programs.zed-editor = {
    enable = true;
    extensions = [
      "dockerfile"
      # disabled until https://github.com/eth0net/zed-docker-compose/issues/2
      # "docker-compose"

      "nix"
    ];
    installRemoteServer = true;
    userSettings = with pkgs; {
      "vim_mode" = true;
      "terminal"."shell"."program" = "fish";

      "lsp"."package-version-server"."binary"."path" = package-version-server + "/bin/package-version-server";
      "lsp"."nixd"."binary"."path" = nixd + "/bin/nixd";
      "lsp"."nil"."binary"."path" = nil + "/bin/nil";
    };
  };
}